<?php
class User {
	public function __construct() {
		try {
			$this->db = new PDO('mysql:host=localhost;dbname=vlachzd1;charset=utf8','vlachzd1','seznamjebozi');
			$this->db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		} catch(PDOException $e)  {
    		echo $e->getMessage();
    	}
	}

	public function validateUser($name, $password) {

		$sql = "SELECT * FROM users WHERE name=:name";

		try {
			$prep = $this->db->prepare($sql);
			$prep->bindParam(":name",$name);
			$prep->execute();
		}
		catch(PDOException $e)  {
    		echo $sql . "<br>" . $e->getMessage();
    	}

		$row = $prep->fetch();

		// spatne jmeno nic se v tabulce nenaslo
		if (count($row) == 0) {
			return false;
		}

		$passwordStored = $row['password'];

		if ($passwordStored == crypt($password, $passwordStored)) {
			$this->_saveStateToSession($row['id'],$row['name']);
			return true;
		} else {
			return false;
		}
	}

	public function registerUser($name, $password) {
		$hashed_password = crypt($password);

		$sql = "INSERT INTO users (name,password) VALUES (:name, :password)";
		try {
			$prep = $this->db->prepare($sql);
			$prep->bindParam(":name",$name);
			$prep->bindParam(":password",$hashed_password);
			$prep->execute();

		} catch(PDOException $e)  {
    		echo $sql . "<br>" . $e->getMessage();
    	}
	}

	private function _saveStateToSession($id,$name) {
		$_SESSION['id'] = $id;
		$_SESSION['name'] = $name;
	}

	public function checkLogged() {
		if (isset($_SESSION['id'])) {
			return true;
		} else {
			return false;
		}
	}

	public function logoutUser() {
		unset($_SESSION['id']);
		unset($_SESSION['name']);
		session_abort();
	}
}
?>